%% this code evaluates the complexity of the bubble sort algorithm for unsorted and presorted input

%take a set of different problem sizes 100<N<10,000
N=ceil(logspace(2,4,10));

%apply bubble sort to a randomized set of N numbers, N varying;
c=[]; 
for i=N, 
    tic
    BubbleSort(rand(i,1)); 
    c(end+1)=toc;
end

%apply bubble sort to a almost sorted set of N numbers, N varying;
c2=[]; 
for i=N, 
    tic
    BubbleSort(rand(i,1)+0.01*(1:i)'); 
    c2(end+1)=toc;
end

%% plot complexity
figure(1)
clf;
loglog(N,c,'.-','DisplayName','bubble sort')
hold on 
loglog(N,c2,'r.-','DisplayName','bubble sort, almost sorted')
xlabel('N')
ylabel('time t[s]')
title('Complexity')

%compare the result with t=O(N) and t=O(N^2)
loglog(N,N.^2/10000000,'DisplayName','O(N^2)')
loglog(N,N/1000000,'r','DisplayName','O(N)')
loglog(N,N.*log(N)/1000000,'r','DisplayName','O(N)')
legend('show')
