function NormalVectors
% plots the function z = x* exp(-x^2 - y^2) and its surface normals.

% close all figures
close all

% setup the vectors
x=linspace(-2,2,100)
y=linspace(-2,2,100)

% compute the function
z = x* exp(-x^2 - y^2);

% plot the surface plot
mesh(x,y,z);

%Compute the surface normals
[nx,ny,nz] = surfnorm(x,y,z);

% For every 10th point plot the surface normal
hold on;
x=x(1:10:100);
y=y(1:1:100);
z=z(1:10:100);
fx=fx(1:10:100);
fy=fy(1:10:100);
quiver3(x,y,z,nx,ny,nz,0.5)
