function main
% this code evaluates the complexity of the bubble sort algorithm for unsorted and presorted input

%take a set of different problem sizes 100<N<10000
n=ceil(logspace(4,8,10));
m=randi(1e9,1,10);
N=min(n,m);

%apply gcd1 to a randomized set of N numbers, N varying;
c=[]; 
for i=1:length(n), 
    tic
    gcd1(n(i),m(i)); 
    c(end+1)=toc;
end

%apply bubble sort to a almost sorted set of N numbers, N varying;
c2=[]; 
for i=1:length(n), 
    tic
    gcd2(n(i),m(i)); 
    c2(end+1)=toc;
end

% plot complexity
figure(1)
clf;
loglog(N,c,'.-','DisplayName','trivial gcd')
hold on 
loglog(N,c2,'r.-','DisplayName','efficient gcd')
xlabel('n')
ylabel('time t[s]')
title('Complexity')

%compare the result with t=O(N) and t=O(N^2)
loglog(N,N/10000000,'r:','DisplayName','O(N)')
legend('show')
set(legend,'Location','Best')

% implementation of first algorithm
function z=gcd1(n,m)
for k=1:min(m,n)
    if mod(k,n)==0 & mod(k,m)==0
        z=k;
    end
end

% implementation of second algorithm
function z=gcd2(n,m)
for z=min(m,n):-1:1
    if mod(z,n)==0 & mod(z,m)==0
        return
    end
end




